# Copyright (C) 1991--2010 by INRIA.
#
# This file is part of Algolib.
#
# Algolib is free software: you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Algolib is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Algolib.  If not, see
# <http://www.gnu.org/licenses/>.

`multiseries/function`[arcsin, 1, "BasisVector", 1/2, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:57`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,1,"CoeffProc",1/2](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/1/BasisVector/1/2/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, -1, "BasisVector", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:51`; [0, MultiSeries:-`multiseries/function`[arcsin,-1,"CoeffProc"](n,0)] end proc:
`multiseries/function`[arcsin, 1, "CoeffProc", 1/2]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:56`; MultiSeries:-`multiseries/function`[arcsin,1,"CoeffProc"](n,1/2) end proc:
`multiseries/function`[arcsin, 1, "BasisVector", 1/2]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:55`; [1/2, MultiSeries:-`multiseries/function`[arcsin,1,"CoeffProc"](n,1/2)] end proc:
`multiseries/function`[arcsin, -1, "BasisVector", 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:53`; [MultiSeries:-`multiseries/function`[arcsin,-1,"BasisVector",0,"MultiSeries",0](args)] end proc:
`multiseries/function`[arcsin]:=proc (expr, scale, var, order) local tmp, re, im, lim, lim2, argseq, res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:45:01`; if expr = 0 then return `multiseries/Convert2SERIES`(arcsin(0),scale,var,false) end if; lim := `multiseries/limit`(expr,scale,var); lim2 := lim; if lim = undefined then error "unable to compute series" elif has(lim,infinity) then lim := infinity end if; if lim = infinity then argseq := `multiseries/pow`(expr,-1,scale,var,order), scale, var, order else argseq := `multiseries/AddDoit`(expr,`multiseries/Convert2SERIES`(-lim,scale,var,false)), scale, var, order end if; if lim = -1 or Testzero(lim+1) then res := `multiseries/function`[arcsin,-1](argseq) elif lim = 0 then res := `multiseries/function`[arcsin,0](argseq) elif lim = 1 or Testzero(lim-1) then res := `multiseries/function`[arcsin,1](argseq) elif lim = infinity then res := `multiseries/function`[arcsin,infinity](argseq) else res := eval(`multiseries/function`[arcsin,_AnyFiniteOrdinaryPoint](argseq),_AnyFiniteOrdinaryPoint = lim) end if; if _Envnobranchcut <> true then if `multiseries/function`["Helper","IsOnBranchCut"]([-1, -infinity],{-1, -infinity},lim2) then userinfo(2,MultiSeries,`branchcut:`,arcsin,[-1, -infinity]); if lim = infinity then im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(expr,-1,algebraic))) else im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(`multiseries/AddDoit`(expr,-lim),-1,algebraic))) end if; if im = 1 then _Envnobranchcut := true; userinfo(2,MultiSeries,`jump:`,arcsin,`multiseries/run`(-Pi-2*arcsin(expr),scale,var,order)); res := `multiseries/run`(-Pi-2*arcsin(expr)+res,scale,var,order); _Envnobranchcut := false elif type(im,specfunc(anything,'signum')) or type(-im,specfunc(anything,signum)) then _Envnobranchcut := true; userinfo(2,MultiSeries,`jump:`,arcsin,`multiseries/run`(1/2*(im+1)*(-Pi-2*arcsin(expr)),scale,var,order)); res := `multiseries/run`(1/2*(im+1)*(-Pi-2*arcsin(expr))+res,scale,var,order); _Envnobranchcut := false end if elif `multiseries/function`["Helper","IsOnBranchCut"]([1, infinity],{1, infinity},lim2) then userinfo(2,MultiSeries,`branchcut:`,arcsin,[1, infinity]); if lim = infinity then im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(expr,1,algebraic))) else im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(`multiseries/AddDoit`(expr,-lim),1,algebraic))) end if; if im = 1 then _Envnobranchcut := true; userinfo(2,MultiSeries,`jump:`,arcsin,`multiseries/run`(Pi-2*arcsin(expr),scale,var,order)); res := `multiseries/run`(Pi-2*arcsin(expr)+res,scale,var,order); _Envnobranchcut := false elif type(im,specfunc(anything,'signum')) or type(-im,specfunc(anything,signum)) then _Envnobranchcut := true; userinfo(2,MultiSeries,`jump:`,arcsin,`multiseries/run`(1/2*(im+1)*(Pi-2*arcsin(expr)),scale,var,order)); res := `multiseries/run`(1/2*(im+1)*(Pi-2*arcsin(expr))+res,scale,var,order); _Envnobranchcut := false end if end if end if; subsop(9 = arcsin(op(9,expr)),res) end proc:
`multiseries/function`[arcsin, 1, "BasisVector", 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:56`; [MultiSeries:-`multiseries/function`[arcsin,1,"BasisVector",0,"MultiSeries",0](args)] end proc:
`multiseries/function`[arcsin, -1, "CoeffProc"]:=proc (n, c) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:51`; if n = 0 then [1] else loc[0] := 1; for i1 to n do loc[i1] := -(c^2-2*c+1+(2*c-2+i1)*i1)*loc[i1-1]/(c-2*c^2+(-4*c+1-2*i1)*i1) end do; [seq(loc[i1],i1 = 0 .. n)] end if end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:59`; [0, MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,0](n)] end proc:
`multiseries/function`[arcsin, infinity, "CoeffProc", 0, 0, 1]:=proc (n) local i1, loc, xxloc1; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:58`; xxloc1 := MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,0](n); loc[0] := 0; loc[1] := 0; loc[2] := 1/4; for i1 from 3 to n do loc[i1] := (-(3-2*i1)*op(i1-1,xxloc1)-2*i1*op(i1+1,xxloc1)-(-2+(3-i1)*i1)*loc[i1-2])/i1^2 end do; [seq(loc[i1],i1 = 0 .. n)] end proc:
`multiseries/function`[arcsin, 1, "BasisVector", 1/2, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:57`; [MultiSeries:-`multiseries/function`[arcsin,1,"BasisVector",1/2,"MultiSeries",0](args)] end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 1, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:45:01`; [MultiSeries:-`multiseries/function`[arcsin,infinity,"BasisVector",0,0,1,"MultiSeries",0](args), MultiSeries:-`multiseries/function`[arcsin,infinity,"BasisVector",0,0,1,"MultiSeries",1](args)] end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 1, "MultiSeries", 1]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:45:00`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/infinity/BasisVector/0/0/1/MultiSeries/1`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, 1, "CoeffProc", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:55`; MultiSeries:-`multiseries/function`[arcsin,1,"CoeffProc"](n,0) end proc:
`multiseries/function`[arcsin, 1]:=proc (expr, scale, var, order) local loc1, loc2, loc3, res, res1, res2; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:57`; ASSERT(MultiSeries:-`multiseries/limit`(expr,scale,var) = 0 or Testzero(MultiSeries:-`multiseries/limit`(expr,scale,var))); loc3 := MultiSeries:-`multiseries/MulSeriesCst`(expr,-1,algebraic); loc1 := MultiSeries:-`multiseries/function`[arcsin,1,"BasisVector",0,"MultiSeries"](loc3,scale,var,order); loc2 := 1/2*Pi; res1 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],0,loc2,1); loc1 := MultiSeries:-`multiseries/function`[arcsin,1,"BasisVector",1/2,"MultiSeries"](loc3,scale,var,order); loc2 := -2^(1/2); res2 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],1/2,loc2,1); res := MultiSeries:-`multiseries/add`([res1, res2]); subsop(9 = arcsin(op(9,expr)),res) end proc:
`multiseries/function`[arcsin, -1, "BasisVector", 1/2, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:54`; [MultiSeries:-`multiseries/function`[arcsin,-1,"BasisVector",1/2,"MultiSeries",0](args)] end proc:
`multiseries/function`[arcsin, 1, "BasisVector", 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:56`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,1,"CoeffProc",0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/1/BasisVector/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, _AnyFiniteOrdinaryPoint]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:50`; MultiSeries:-`multiseries/compose`(SERIES(scale,map(normal,MultiSeries:-`multiseries/function`[arccos,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,arcsin(_AnyFiniteOrdinaryPoint),1/(1-_AnyFiniteOrdinaryPoint^2)^(1/2),_AnyFiniteOrdinaryPoint)),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),arcsin(_AnyFiniteOrdinaryPoint+eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[arcsin, -1, "CoeffProc", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:52`; MultiSeries:-`multiseries/function`[arcsin,-1,"CoeffProc"](n,0) end proc:
`multiseries/function`[arcsin, -1, "BasisVector", 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:53`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,-1,"CoeffProc",0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/-1/BasisVector/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, -1, "BasisVector", 1/2, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:53`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,-1,"CoeffProc",1/2](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/-1/BasisVector/1/2/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 1, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:45:00`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,1](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/infinity/BasisVector/0/0/1/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, -1]:=proc (expr, scale, var, order) local loc1, loc2, loc3, res, res1, res2; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:54`; ASSERT(MultiSeries:-`multiseries/limit`(expr,scale,var) = 0 or Testzero(MultiSeries:-`multiseries/limit`(expr,scale,var))); loc3 := MultiSeries:-`multiseries/MulSeriesCst`(expr,1,algebraic); loc1 := MultiSeries:-`multiseries/function`[arcsin,-1,"BasisVector",0,"MultiSeries"](loc3,scale,var,order); loc2 := -1/2*Pi; res1 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],0,loc2,-1); loc1 := MultiSeries:-`multiseries/function`[arcsin,-1,"BasisVector",1/2,"MultiSeries"](loc3,scale,var,order); loc2 := 2^(1/2); res2 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],1/2,loc2,-1); res := MultiSeries:-`multiseries/add`([res1, res2]); subsop(9 = arcsin(op(9,expr)),res) end proc:
`multiseries/function`[arcsin, -1, "BasisVector", 1/2]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:52`; [1/2, MultiSeries:-`multiseries/function`[arcsin,-1,"CoeffProc"](n,1/2)] end proc:
`multiseries/function`[arcsin, 1, "BasisVector", 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:55`; [0, MultiSeries:-`multiseries/function`[arcsin,1,"CoeffProc"](n,0)] end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 1]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:59`; [0, MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,1](n), MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,0](n)] end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:45:00`; [MultiSeries:-`multiseries/function`[arcsin,infinity,"BasisVector",0,0,0,"MultiSeries",0](args)] end proc:
`multiseries/function`[arcsin, -1, "CoeffProc", 1/2]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:52`; MultiSeries:-`multiseries/function`[arcsin,-1,"CoeffProc"](n,1/2) end proc:
`multiseries/function`[arcsin, infinity, "CoeffProc", 0, 0, 0]:=proc (n) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:58`; loc[0] := 1; loc[1] := 0; loc[2] := 0; for i1 from 3 to n do loc[i1] := -(-2+(3-i1)*i1)*loc[i1-2]/i1^2 end do; [seq(loc[i1],i1 = 0 .. n)] end proc:
`multiseries/function`[arcsin, 1, "CoeffProc"]:=proc (n, c) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:54`; if n = 0 then [1] else loc[0] := 1; for i1 to n do loc[i1] := -(-c^2+2*c-1+(-2*c+2-i1)*i1)*loc[i1-1]/(-c+2*c^2+(4*c-1+2*i1)*i1) end do; [seq(loc[i1],i1 = 0 .. n)] end if end proc:
`multiseries/function`[arcsin, infinity]:=proc (expr, scale, var, order) local loc1, loc2, res, res1, res2; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:45:01`; ASSERT(MultiSeries:-`multiseries/limit`(expr,scale,var) = 0 or Testzero(MultiSeries:-`multiseries/limit`(expr,scale,var))); loc1 := MultiSeries:-`multiseries/function`[arcsin,infinity,"BasisVector",0,0,0,"MultiSeries"](expr,scale,var,order); loc2 := -I*ln(2*I); res1 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[expr, scale, var, order],0,loc2,infinity); loc1 := MultiSeries:-`multiseries/function`[arcsin,infinity,"BasisVector",0,0,1,"MultiSeries"](expr,scale,var,order); loc2 := I; res2 := MultiSeries:-`multiseries/function`["Helper","RegularBasisVector"](loc1,[expr, scale, var, order],0,loc2,infinity); res := MultiSeries:-`multiseries/add`([res1, res2]); subsop(9 = arcsin(op(9,expr)),res) end proc:
`multiseries/function`[arcsin, infinity, "BasisVector", 0, 0, 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:59`; SERIES(scale,MultiSeries:-`multiseries/function`[arcsin,infinity,"CoeffProc",0,0,0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arcsin/infinity/BasisVector/0/0/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arcsin, 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 09/24/2004 @ 10:44:51`; MultiSeries:-`multiseries/compose`(SERIES(scale,MultiSeries:-`multiseries/function`[arccos,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,0,1,0),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),arcsin(eval(scale['variable'],1))),expr,scale,var,order) end proc:
